
Ruby - Bug #13008

File::basename fails if extension contains a colon

12/05/2016 01:41 PM - rovf (Ronald Fischer)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.2.4p230 (2015-12-16 revision

53155) [x86_64-cygwin]

Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:

UNKNOWN

Description

 File.basename('a/b/c.d:12')

 returns

c.d

 but should return

c.d:12

Associated revisions

Revision 7eb8d74f34b9294e7da3d9f2db13e94503a3dd25 - 12/07/2016 02:19 AM - nobu (Nobuyoshi Nakada)

file.c: cygwin behavior

file.c: recent cygwin hides NTFS specific features.

[ruby-core:78497] [Bug #13008]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57009 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7eb8d74f - 12/07/2016 02:19 AM - nobu (Nobuyoshi Nakada)

file.c: cygwin behavior

file.c: recent cygwin hides NTFS specific features.

[ruby-core:78497] [Bug #13008]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57009 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/05/2016 02:59 PM - jeremyevans0 (Jeremy Evans)

I don't think this is a bug. : is the file stream separator in NTFS (

https://blogs.technet.microsoft.com/askcore/2013/03/24/alternate-data-streams-in-ntfs/).  On *nix systems, you do get c.d:12.

#2 - 12/06/2016 01:28 AM - nobu (Nobuyoshi Nakada)

I did think so, but on recent cygwin, touch c.d:12 makes a file "c.d\u{F03A}12".

Seems : is mapped to that Private Use Area character.

I'm not sure if we should support it now.

#3 - 12/07/2016 02:19 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r57009.

file.c: cygwin behavior

file.c: recent cygwin hides NTFS specific features.

[ruby-core:78497] [Bug #13008]
